#include <fxlib.h>
#include "menu.h"
#include "syscall.h"

void write(char* offset, int length)
{
	int file, key, i, name_length=0, cur=0;
	FONTCHARACTER filename[19] = {'\\','\\','f','l','s','0','\\'};
	char name[13] = {0};
	PopUpWin(5);
	locate(3, 2);
	Print("File Name");
	Cursor_SetFlashMode(1);
	do {
		locate(3, 3);
		Print("[        ]");
		locate(4, 3);
		Print(name);
		locate(cur+4, 3);
		GetKey(&key);
		switch(key) {
			case KEY_CTRL_EXIT: return;
			case KEY_CTRL_DEL:
				if(cur) {
					for(i=cur-1 ; i<name_length ; i++) name[i] = name[i+1];
					cur--;
					name_length--;
				}else if(name_length) {
					for(i=0 ; i<name_length ; i++) name[i] = name[i+1];
					name_length--;
				}
				break;
			case KEY_CTRL_LEFT:
				if(cur) cur--;
				break;
			case KEY_CTRL_RIGHT:
				if(cur<name_length) cur++;
				break;
			default:
				if(name_length<8 && ((key>='A' && key<='Z') || (key>='0' && key<='9'))) {
					if(cur<name_length) {
						for(i=name_length ; i>cur ; i--)
							name[i] = name[i-1];
					}
					name[cur] = key;
					name_length++;
					cur++;
				}
		}
	} while(key!=KEY_CTRL_EXE || name_length==0);
	Cursor_SetFlashMode(0);
	name[name_length] = '.';
	name[name_length+1] = 't';
	name[name_length+2] = 'x';
	name[name_length+3] = 't';
	for(i=0 ; name[i] ; i++) filename[i+7] = name[i];
	
	if((file = Bfile_OpenFile(filename, _OPENMODE_READ)) >= 0) {
		Bfile_CloseFile(file);
		PopUpWin(5);
		locate(3, 2);
		Print("[");
		Print(name);
		locate(17, 3);
		Print("]");
		locate(3, 3);
		Print("Already Exists");
		locate(3, 4);
		Print("Overwrite OK?");
		locate(6, 5);
		Print("Yes:[F1]");
		locate(6, 6);
		Print("No :[F6]");
		while(key != KEY_CTRL_F1) {
			GetKey(&key);
			if(key == KEY_CTRL_F6) return;
		}
		Bfile_DeleteFile(filename);
	}
	Bfile_CreateFile(filename, length);
	if((file = Bfile_OpenFile(filename, _OPENMODE_WRITE)) >= 0) {
		Bfile_WriteFile(file, offset, length);
		Bfile_CloseFile(file);
		PopUpWin(4);
		locate(7, 3);
		Print("Complete!");
		locate(6, 5);
		Print("Press:[EXIT]");
		while(key != KEY_CTRL_EXIT) GetKey(&key);
	}
}

int AddIn_main(int isAppli, unsigned short OptionNum)
{
	char* offset;
	int length;
	while(1) {
		menu(&offset, &length);
		write(offset, length);
	}
	return 1;
}


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section
#pragma section _TOP
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
	return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}
#pragma section
